% ================ vyvazena realizacia pre male matice trojkapacitnho vymennka =================
clear
clc
%index 1 = vnutorna rurka
%index 3 = vonkajsia rurka
%petrolej je vo vnutornej rurke pre zadania 3, 7, 11
%voda je vo vnutornej rurke pre zadania 4, 8, 12, 14
d12=25e-3;%m
d23=28e-3;%m
d3=50e-3;%m
alfa12=750;%Js-1m-2K-1
alfa23=1480;%Js-1m-2K-1
m1b=1100/3600;%kgs-1
m3b=400/3600;%kgs-1
ro1=810;%kgm-3
ro2=8930;%kgm-3
ro3=1000;%kgm-3
cp1=2.1e3;%Jkg-1K-1
cp2=.385e3;%kg-1K-1
cp3=4.2e3;%Jkg-1K-1
l=10;%m
n=5;%pocet usekov
dz=l/n;%m
l(1)=0;%m
theta1(1)=20;%oC
theta3(1)=75;%oC

q1=m1b/ro1;
q3=m3b/ro3;
t1=d12*ro1*cp1/(4*alfa12)
w1=4*q1/(pi*d12^2)
t2=(d23^2-d12^2)*ro2*cp2/(4*(d23*alfa23+d12*alfa12))
z21=d12*alfa12/(d12*alfa12+d23*alfa23)
z23=d23*alfa23/(d12*alfa12+d23*alfa23)
%z23=d12*alfa12/(d12*alfa12+d23*alfa23);
%z21=d23*alfa23/(d12*alfa12+d23*alfa23);
t3=(d3^2-d23^2)*ro3*cp3/(4*d23*alfa23)
w3=4*q3/(pi*(d3^2-d23^2))


a=t1*w1/dz;
b=a+1;
c=t3*w3/dz;
d=c+1;
e=1-z21/b;
f=1-z23/d;
g=1-z23*z21/(b*e*d*f);
h=z23*c/(b*e*d*f);

theta2(1)=z23*theta3(1)+z21*theta1(1);
for i=2:n+1
   theta1(i)=a/(b*e*g)*theta1(i-1)+h/g*theta3(i-1);
   theta3(i)=c/(d*f)*theta3(i-1)+z21/(d*f)*theta1(i);
   theta2(i)=z23*theta3(i)+z21*theta1(i);
   l(i)=l(i-1)+dz;
end
% theta1;
% theta2;
% theta3;
% plot(l,theta1,l,theta2,l,theta3)

%matice A,B,C,D tie male

a11=-(1/t1+w1/dz);a12=1/t1;a13=0;
a21=z21/t2;a22=-1/t2;a23=z23/t2;
a33=-(1/t3+w3/dz);a32=1/t3;a31=0;
A=[a11 a12 a13;a21 a22 a23;a31 a32 a33] 
b11=w1/dz;b12=0;
b21=0;b22=0;
b31=0;b32=w3/dz;
B=[b11 b12;b21 b22;b31 b32]
B1=[b11; 0;0]
B2=[0;0;b32];
% C=eye(3)
C=[0 0 0; 0 0 0; 0 0 1]
%  D=zeros(3,2)
D=[0;0;0]

Q=eye(3);
 R=1;
 eig(A)
sys = ss(A,B2,C,D)

[cit,men] = ss2tf(A,B2,C,D,1)
cit1=cit(1,:)
Gs = tf(cit1,men)

% Ak chces aby ti vyplulo vsetky styri argumenty, tak musis pouzit
% State-Space model ako vstup do prikazu balreal

[SYSb,G1,T,Ti] = balreal(sys)

% SYSb mozes potom prehodit na TF pomocou ss2tf ! ALE !...
% tam je jeden zadrhel, ze najprv musis vytiahnut matice z premennej SYSb a
% to takto:

Ab = SYSb.a
Bb = SYSb.b
Cb = SYSb.c
Db = SYSb.d

[citb,denb] = ss2tf(Ab,Bb,Cb,Db)
citb1=citb(3,:)
Gsb = tf(citb1,denb)


 AA=T*A*Ti
 BB=T*B2
 CC=C*Ti
    DD=[0]
 
 L=[1 0 0]*Ti;
F=L*A*L'*inv((L*L'))
G=L*B2
Q=eye(3);
R=1;
QA=inv((L*L'))*L*Q*L'*inv(L*L');
alfa=1;
FA=F+alfa;
% -(G*inv(R)*G'),(2*FA),(QA+2*alfa)
riesric=roots([-(G*inv(R)*G'),(2*FA),(QA+2*alfa)]);
KB=inv(R)*G'*riesric(1);
uab=KB*L
uab1=uab(1,:)
  
% uab1 =
% 
%     1.4255  -11.8447   39.4554
% ----------------------------------------2.rd------------------------
% redukcia modelu na 2.rd
Gs2=modred(SYSb,[3])
% a2=[ -0.3862   0.05912;0.1617  -0.09215];
%  b2=[ 0.6045;-0.1364];
% %  pre c2 si vyberam y1
%  cc2=[0.5729  -0.09222];
% %  pre d je y1  u1=0.01398 tak som to dala nula
%  d2=[0];
%  ak nas zaujima iba voda
% a2=[-0.422  0.04999;0.04999  -0.0695];
% b2=[0.6088;-0.03686];
% c2=[0.6088  -0.03686];
% d2=[0]
% ak nas  zaujima iba petrolej
a2=[-0.04622  -0.01643;-0.01643   -0.3916];
 b2=[ 0.1997; 0.03564];
c2=[0.1997  0.03564];
d2=[0]
[cit2,men2]=ss2tf(a2,b2,c2,d2,1)
Gs2_p=tf(cit2,men2) 


% Transfer function: pre petrolej
%   0.04115 s + 0.01544
% ------------------------
% s^2 + 0.4378 s + 0.01783

% % PI regulator 9.6411;ti2.2756
%  River Morari podla  zieglera-nicolsonaZr=1.396 TI=2.477   3.458
% Gr2=tf([ 3.458 1.396],[2.477 0]);
% ziegler-nicolson 
Zr=11.2416; Ti=14.6073;
Gr2=tf([(Zr*Ti) Zr ],[Ti 0]);
  Go2=Gs2_p*Gr2;
  Gu2=Go2/(1+Go2);
 Gu2=minreal(Gu2);
 Go=Gs*Gr2;
  Gu=Go/(1+Go);
  Gu=minreal(Gu);
 figure(2)
step(Gu2,'r',Gu,'--');
title('2.rad')

% ----------------------------------------1.rd------------------------
 % redukcia modelu na 1.rd
Gs1=modred(SYSb,[2 3])
%  a1=[-0.2825 ];
% b1=[0.517];
% % vybrala som si zase y1=u1
%   c1=[0.4111];
% %   pre D som nechala o lebo ta hodnota y1=u1=0.1505
%  d1=[0];

a1=[-0.04553];
b1=[0.1982];
c1=[0.1982];
d1=[0];
[cit1,men1]=ss2tf(a1,b1,c1,d1,1)
Gs1_p=tf(cit1,men1)

 
% Transfer function:
%   0.03928
% -----------
% s + 0.04553
% % PI regulator
%   River Morari podla Zr= 1.386; Ti=3.5448;

  Zr=1.2917;Ti=19.7136;

Gr1=tf([(Zr*Ti) Zr ],[Ti 0]);  
 Go1=Gs1_p*Gr1
 Gu1=Go1/(1+Go1)
 Gu1=minreal(Gu1)
 Go=Gs*Gr1
 Gu=Go/(1+Go)
 Gu=minreal(Gu)
 figure(1)
 step(Gu1,'r',Gu,'--')
 title('1.rad')
