close all
clc
clear
% Voda:
q1  = 1.15e-004; 
ro1 = 1000;    
cp1 = 4200;     
%Petrolej:
q3  = 3.77e-004; 
ro3 = 810;       
cp3 = 2100;      
 
%rozmery prierezu
d1 = 0.025;      
d2 = 0.0265;     
d3 = 0.050;      
 
%dlzka vymennika:
L = 10;          
%udaje o rozhrani
alfa1  = 1480;   
alfa3  = 750;    
lambda = 395;    
ro = 8930;        
cp = 385;     
 
%konsanty vypocet: 
koef1=1/(1/alfa1+(d1/(2*lambda))*log(d1/d2)+d1/(alfa3*d2))
koef3=1/(1/alfa3+(d2/(2*lambda))*log(d2/d1)+d2/(alfa1*d1))
 
T3=(ro3*(d3^2-d2^2)*cp3)/(koef3*d2*4)
T1=(d1*ro1*cp1)/(4*koef1)
w1 = (4*q1)/(pi*d1^2)
w3 = (4*q3)/(pi*(d3^2-d2^2))
L = 10;          %m
n=5;
deltaz = L/n;

%udaje o rozhrani
alfa1  = 1480;   %W.m-2.K-1
alfa3  = 750;    %W.m-2.K-1
lambda = 395;    %W.m-1.K-1
ro = 8930;       %kg.m-3 
cp = 385;        %J.kg-1.K-1   
 
%konsanty vypocet: 
koef1=1/(1/alfa1+(d1/(2*lambda))*log(d1/d2)+d1/(alfa3*d2));
koef3=1/(1/alfa3+(d2/(2*lambda))*log(d2/d1)+d2/(alfa1*d1));
 
T3=(ro3*(d3^2-d2^2)*cp3)/(koef3*d2*4)
T1=(d1*ro1*cp1)/(4*koef1)
w1 = (4*q1)/(pi*d1^2)
w3 = (4*q3)/(pi*(d3^2-d2^2))
 
%const a1,a3,T1,T3:
 
a1 = ((T1*w1)/deltaz)+1;
a3 = ((T3*w3)/deltaz)+1;
b1 = (T1*w1)/deltaz;
b3 = (T3*w3)/deltaz;
AA=[-a1/T1 1/T1; 1/T3 -a3/T3]
 B=[b1/T1 0; 0 b3/T3]
 B1=B(:,2)
 C=[1 0; 0 1]
 D1=[0 0;0 0]
 d=[0;0]
%=============== presna agregacia  ==========================
eig(AA)
% Nsledne bola vypotan transforman matica T v prostred MATLAB pomocou prkazu
[T,D]=eig(AA)
inverT=T^-1;
L=inverT(1,:)
F=L*AA*L'*inv((L*L'));
G=L*B1;
Q=eye(2);
R=1 ;
QA=inv((L*L'))*L*Q*L'*inv(L*L');
alfa=1;
FA=F+alfa;
riesriccatiho=roots([-(G*inv(R)*G'),(2*FA),(QA+2*alfa)]);
 KA=inv(R)*G'*riesriccatiho(1);
 ua=KA*L;
 ua1=real(ua)
% ua1 =
% 
%    17.5674   13.2032
%  ====================== modlna agregcia ====================
Q=eye(2);
R=1;
eig(AA)
[Ma,Ja]=jordan(AA);
Ja=real(Ja)
Ma=real(Ma);
Mr=Ma(1,1);
P=[1 0];
% agregacna matica L
L=Mr*P*inv(Ma);
% Agregovan7 system 
Ar=Mr*P*Ja*P'*inv(Mr); % nase F
Ar=real(Ar)
Br=Mr*P*inv(Ma)*B1  % nase G
QA=inv((L*L'))*L*Q*L'*inv(L*L');
alfa=1;
FA=Ar+alfa;
riesriccatiho=roots([-(Br*inv(R)*Br'),(2*FA),(QA+2*alfa)]);
KA=inv(R)*Br'*riesriccatiho(1);
uaa=KA*L;
% vypisovanie realnej casti
ua2=real(uaa)
% ua2 =
% 
%    17.5460   13.1871
% % 
