% ========================== realizcia pre male matice

% Voda:
q1  = 1.15e-004; 
ro1 = 1000;    
cp1 = 4200;     
%Petrolej:
q3  = 3.77e-004; 
ro3 = 810;       
cp3 = 2100;      
 
%rozmery prierezu
d1 = 0.025;      
d2 = 0.0265;     
d3 = 0.050;      
 
%dlzka vymennika:
L = 10;          
%udaje o rozhrani
alfa1  = 1480;   
alfa3  = 750;    
lambda = 395;    
ro = 8930;        
cp = 385;     
 
%konsanty vypocet: 
koef1=1/(1/alfa1+(d1/(2*lambda))*log(d1/d2)+d1/(alfa3*d2))
koef3=1/(1/alfa3+(d2/(2*lambda))*log(d2/d1)+d2/(alfa1*d1))
 
T3=(ro3*(d3^2-d2^2)*cp3)/(koef3*d2*4)
T1=(d1*ro1*cp1)/(4*koef1)
w1 = (4*q1)/(pi*d1^2)
w3 = (4*q3)/(pi*(d3^2-d2^2))
L = 10;          %m
n=5;
deltaz = L/n;

%udaje o rozhrani
alfa1  = 1480;   %W.m-2.K-1
alfa3  = 750;    %W.m-2.K-1
lambda = 395;    %W.m-1.K-1
ro = 8930;       %kg.m-3 
cp = 385;        %J.kg-1.K-1   
 
%konsanty vypocet: 
koef1=1/(1/alfa1+(d1/(2*lambda))*log(d1/d2)+d1/(alfa3*d2));
koef3=1/(1/alfa3+(d2/(2*lambda))*log(d2/d1)+d2/(alfa1*d1));
 
T3=(ro3*(d3^2-d2^2)*cp3)/(koef3*d2*4)
T1=(d1*ro1*cp1)/(4*koef1)
w1 = (4*q1)/(pi*d1^2)
w3 = (4*q3)/(pi*(d3^2-d2^2))
 
%const a1,a3,T1,T3:
 
a1 = ((T1*w1)/deltaz)+1;
a3 = ((T3*w3)/deltaz)+1;
b1 = (T1*w1)/deltaz;
b3 = (T3*w3)/deltaz;

% ========================== vyvaena korelacia
A=[-a1/T1 1/T1; 1/T3 -a3/T3]
 B=[b1/T1 0; 0 b3/T3]
 B1=B(:,2)
 C=[0 0; 0 1]
%   D=[0 0;0 0]
  D=[0;0]
eig(A)
sys = ss(A,B1,C,D)

[cit,men] = ss2tf(A,B1,C,D,1)
 cit1=cit(1,:)
Gs = tf(cit1,men)
% Ak chces aby ti vyplulo vsetky styri argumenty, tak musis pouzit
% State-Space model ako vstup do prikazu balreal

[SYSb,G1,T,Ti] = balreal(sys)
Ab = SYSb.a
Bb = SYSb.b
Cb = SYSb.c
Db = SYSb.d

[citb,denb] = ss2tf(Ab,Bb,Cb,Db,1)
citb1=citb(2,:)
Gsb = tf(citb1,denb)
 

 AA=T*A*Ti
 BB=T*B1
 CC=C*Ti
    DD=[0]
L=[1 0]*Ti;
F=L*A*L'*inv((L*L'));
G=L*B1;
Q=eye(2);
R=1;
QA=inv((L*L'))*L*Q*L'*inv(L*L');
alfa=1;
FA=F+alfa;
-(G*inv(R)*G'),(2*FA),(QA+2*alfa);
riesric=roots([-(G*inv(R)*G'),(2*FA),(QA+2*alfa)]);
KB=inv(R)*G'*riesric(1);
uab=KB*L
uab1=uab(1,:)
% uab1 =
% 
%     3.4670   12.9518

%     Gsb
%  
% Transfer function:
%    0.1171 s + 0.01762
% ------------------------
% s^2 + 0.2873 s + 0.02025
% ----------------------------------------1.rd------------------------
% redukcia modelu na 1.rd

 Gs1=modred(SYSb,[2])
% a1=[-0.1312];
% b1=[ -0.3386];
% c1=[-0.334];
% d1=[0];
a1=[-0.1454];
b1=[-0.3614];
c1=[-0.3614];
d1=[0];
[cit1,men1]=ss2tf(a1,b1,c1,d1,1)
Gs1_p=tf(cit1,men1)
%   0.1306
% ----------
% s + 0.1454

% PI regulator
% vypocitat Gr1   Zr=1.1617; Ti=7.6162
%   Gr1=tf([8.8477 1.1617 ],[7.6162 0]);  
Zr=14.2006;Ti=1.8548;
Gr1=tf([(Zr*Ti) Zr ],[Ti 0]);  
 Go1=Gs1_p*Gr1
 Gu1=Go1/(1+Go1)
 Gu1=minreal(Gu1)
 Go=Gs*Gr1
 Gu=Go/(1+Go)
 Gu=minreal(Gu)
 figure(1)
 step(Gu1,'r',Gu,'--')
 title('1.radu')
 
