% Vyvazena korelcia
clear
clc

 A=[-3 1 2; 2 -4 0; 2 0 -2];
% A=[-4 2 2; 3 -4 1; 1 1 -4];
% A=[-4 1 2; 2 -4 1; 2 0 -2];
 
% zvolila som si
B=[0; 0; 2];
C=[1 1 1];
D=[0]
 Q=eye(3);
 R=1;
 eig(A)
sys = ss(A,B,C,D)

[cit,men] = ss2tf(A,B,C,D,1)
Gs = tf(cit,men)

% Ak chces aby ti vyplulo vsetky styri argumenty, tak musis pouzit
% State-Space model ako vstup do prikazu balreal

[SYSb,G1,T,Ti] = balreal(sys)

% SYSb mozes potom prehodit na TF pomocou ss2tf ! ALE !...
% tam je jeden zadrhel, ze najprv musis vytiahnut matice z premennej SYSb a
% to takto:

Ab = SYSb.a
Bb = SYSb.b
Cb = SYSb.c
Db = SYSb.d

[citb,denb] = ss2tf(Ab,Bb,Cb,Db)

Gsb = tf(citb,denb)


 AA=T*A*Ti
 BB=T*B
 CC=C*Ti
    DD=[0]
 
 L=[1 0 0]*Ti;
F=L*A*L'*inv((L*L'))
G=L*B
Q=eye(3);
R=1;
QA=inv((L*L'))*L*Q*L'*inv(L*L');
alfa=1;
FA=F+alfa;
-(G*inv(R)*G'),(2*FA),(QA+2*alfa)
riesric=roots([-(G*inv(R)*G'),(2*FA),(QA+2*alfa)]);
KB=inv(R)*G'*riesric(1);
uab=KB*L
% ----------------------------------------2.rd------------------------
% redukcia modelu na 2.rd
Gs2=modred(SYSb,[3])

 a2=[ -0.2086   0.1843;-0.1843   -2.836];
 b2=[ 1.525;0.6643];
 c2=[1.525  -0.6643];
 d2=[0];
 
[cit2,men2]=ss2tf(a2,b2,c2,d2,1)
Gs2_p=tf(cit2,men2)
% 
% % PI regulator
% %  Gr2=tf([0.639 0.090918],[7.0331 0]);
  Gr2=tf([0.36365 0.95915],[0.37914 0]);
  Go2=Gs2_p*Gr2;
  Gu2=Go2/(1+Go2);
 Gu2=minreal(Gu2);
 Go=Gs*Gr2;
  Gu=Go/(1+Go);
  Gu=minreal(Gu);
 figure(2)
step(Gu2,'r',Gu,'--')
% ----------------------------------------1.rd------------------------
 % redukcia modelu na 1.rd
Gs1=modred(SYSb,[2 3])
 a1=[-0.2205 ];
b1=[1.568];
  c1=[1.568];
 d1=[0];
[cit1,men1]=ss2tf(a1,b1,c1,d1,1)
Gs1_p=tf(cit1,men1)

% PI regulator
% vypocitat Gr1
%  Gr1=tf([1.59165 0.81],[1.965 0]);
%  Gr1=tf([0.251 0.32176],[0.77974 0]);
  Gr1=tf([1.10756 0.67567],[1.639 0]);  
% Gr1=tf([0.2452 0.3145],[0.77974 0]);
 Go1=Gs1_p*Gr1
 Gu1=Go1/(1+Go1)
 Gu1=minreal(Gu1)
 Go=Gs*Gr1
 Gu=Go/(1+Go)
 Gu=minreal(Gu)
 figure(1)
 step(Gu1,'r',Gu,'--')
 
[cit3,men3]=ss2tf(AA,BB,CC,0,1)
 Gs2_p=tf(cit3,men3)
 Gr2=tf([0.503 0.056819],[8.8585 0])
% Gr2=tf([3.755 0.38232],[9.8206 0])

 Go2=Gs2_p*Gr2
 Gu2=Go2/(1+Go2)
 Gu2=minreal(Gu2)
 Go=Gs*Gr2
 Gu=Go/(1+Go)
 Gu=minreal(Gu)
 figure(3)
 step(Gu2,'r',Gu,'--')