%VYPOCET US 3KRVT suprudoveho priklad3
clear
clc
%index 1 = vnutorna rurka
%index 3 = vonkajsia rurka
%petrolej je vo vnutornej rurke pre zadania 3, 7, 11
%voda je vo vnutornej rurke pre zadania 4, 8, 12, 14
d12=25e-3;%m
d23=28e-3;%m
d3=50e-3;%m
alfa12=750;%Js-1m-2K-1
alfa23=1480;%Js-1m-2K-1
m1b=1100/3600;%kgs-1
m3b=400/3600;%kgs-1
ro1=810;%kgm-3
ro2=8930;%kgm-3
ro3=1000;%kgm-3
cp1=2.1e3;%Jkg-1K-1
cp2=.385e3;%kg-1K-1
cp3=4.2e3;%Jkg-1K-1
l=10;%m
n=5;%pocet usekov
dz=l/n;%m
l(1)=0;%m
theta1(1)=20;%oC teplota petrolej
theta3(1)=75;%oC teplota vody

q1=m1b/ro1;
q3=m3b/ro3;
t1=d12*ro1*cp1/(4*alfa12)
w1=4*q1/(pi*d12^2)
t2=(d23^2-d12^2)*ro2*cp2/(4*(d23*alfa23+d12*alfa12))
z21=d12*alfa12/(d12*alfa12+d23*alfa23)
z23=d23*alfa23/(d12*alfa12+d23*alfa23)
%z23=d12*alfa12/(d12*alfa12+d23*alfa23);
%z21=d23*alfa23/(d12*alfa12+d23*alfa23);
t3=(d3^2-d23^2)*ro3*cp3/(4*d23*alfa23)
w3=4*q3/(pi*(d3^2-d23^2))


a=t1*w1/dz;
b=a+1;
c=t3*w3/dz;
d=c+1;
e=1-z21/b;
f=1-z23/d;
g=1-z23*z21/(b*e*d*f);
h=z23*c/(b*e*d*f);

theta2(1)=z23*theta3(1)+z21*theta1(1);
for i=2:n+1
   theta1(i)=a/(b*e*g)*theta1(i-1)+h/g*theta3(i-1);
   theta3(i)=c/(d*f)*theta3(i-1)+z21/(d*f)*theta1(i);
   theta2(i)=z23*theta3(i)+z21*theta1(i);
   l(i)=l(i-1)+dz;
end
 theta1
 theta2
 theta3
plot(l,theta1,'-.',l,theta2,l,theta3)
 grid on
xlabel('useky [m]')
ylabel('teploty [C]')
legend('teplota petroleja',' teplota steny',' teplota vody','Best')
%matice A,B,C,D tie male

a11=-(1/t1+w1/dz);a12=1/t1;a13=0;
a21=z21/t2;a22=-1/t2;a23=z23/t2;
a33=-(1/t3+w3/dz);a32=1/t3;a31=0;
AA=[a11 a12 a13;a21 a22 a23;a31 a32 a33] 
b11=w1/dz;b12=0;
b21=0;b22=0;
b31=0;b32=w3/dz;
B=[b11 b12;b21 b22;b31 b32]
% B1=[b11; 0; 0]; toto je pre vodu
B2=[0;0;b32]
C=eye(3)
D1=zeros(3,2);
d=[0;0;0]

%=============== presna agregacia  ==========================
eig(AA)
% Nsledne bola vypotan transforman matica T v prostred MATLAB pomocou prkazu
[T,D]=eig(AA);
inverT=T^-1;
L=inverT(1,:);
F=L*AA*L'*inv((L*L'));
G=L*B2
Q=eye(3);
R=1 ;
QA=inv((L*L'))*L*Q*L'*inv(L*L');
alfa=1;
FA=F+alfa;
riesriccatiho=roots([-(G*inv(R)*G'),(2*FA),(QA+2*alfa)]);
 KA=inv(R)*G'*riesriccatiho(1);
 ua=KA*L;
 ua1=real(ua)
%  ua1 =
% 
%    48.8166  -34.9879   21.7003
 
%  ====================== modlna agregcia ====================
Q=eye(3);
R=1;
eig(AA)
[Ma,Ja]=jordan(AA);
Ja=real(Ja)
Ma=real(Ma);
Mr=Ma(1,1);
P=[1 0 0];
% agregacna matica L
L=Mr*P*inv(Ma);
% Agregovan7 system 
Ar=Mr*P*Ja*P'*inv(Mr); % nase F
Ar=real(Ar);
Br=Mr*P*inv(Ma)*B2; % nase G
QA=inv((L*L'))*L*Q*L'*inv(L*L');
alfa=1;
FA=Ar+alfa;
riesriccatiho=roots([-(Br*inv(R)*Br'),(2*FA),(QA+2*alfa)]);
KA=inv(R)*Br'*riesriccatiho(1);
uaa=KA*L;
% vypisovanie realnej casti
ua2=real(uaa)
% ua2 =
% 
%     0.9619    2.8698   46.3363

