clc
clear
 A=[-3 1 -4; 2 -2 3; 5 6 5];

 
% zvolila som si
B=[0; 0; 2];
C=[1 1 1];
D=[0];
 Q=eye(3);
 R=1;
 eig(A)
sys = ss(A,B,C,D)

[cit,men] = ss2tf(A,B,C,D,1)
Gs = tf(cit,men)

% Ak chces aby ti vyplulo vsetky styri argumenty, tak musis pouzit
% State-Space model ako vstup do prikazu balreal

[SYSb,G1,T,Ti] = balreal(sys)

% SYSb mozes potom prehodit na TF pomocou ss2tf ! ALE !...
% tam je jeden zadrhel, ze najprv musis vytiahnut matice z premennej SYSb a
% to takto:

Ab = SYSb.a
Bb = SYSb.b
Cb = SYSb.c
Db = SYSb.d

[citb,denb] = ss2tf(Ab,Bb,Cb,Db)

Gsb = tf(citb,denb)


 AA=T*A*Ti
 BB=T*B
 CC=C*Ti
 
 L=[1 0 0]*Ti;
F=L*A*L'*inv((L*L'));
G=L*B;
Q=eye(3);
R=1;
QA=inv((L*L'))*L*Q*L'*inv(L*L');
alfa=1;
FA=F+alfa;
riesric=roots([-(G*inv(R)*G'),(2*FA),(QA+2*alfa)]);
KB=inv(R)*G'*riesric(1);
uab=KB*L
% ----------------------------------------2.rd------------------------
% redukcia modelu na 2.rd
Gs2=modred(SYSb,[3])

  a2=[ 4.385  0;   0  -0.05275];
  b2=[ 2.992;-0.1482];
 c2=[0.6354  -0.1482];
 d2=[0.01694];

% a = 
%              x1        x2
%    x1     4.385         0
%    x2         0  -0.05275
%  
% b = 
%             u1
%    x1    2.992
%    x2  -0.1482
%  
% c = 
%             x1       x2
%    y1   0.6354  -0.1482
%  
% d = 
%             u1
%    y1  0.01694
 
[cit2,men2]=ss2tf(a2,b2,c2,d2,1)
Gs2_p=tf(cit2,men2)

% ----------------------------------------1.rd------------------------
 % redukcia modelu na 1.rd
Gs1=modred(SYSb,[2 3])
  a1=[4.385 ];
b1=[2.992];
   c1=[0.6354];
  d1=[0.4335];

[cit1,men1]=ss2tf(a1,b1,c1,d1,1)
Gs1_p=tf(cit1,men1)
